// fg_io.hxx -- Higher level I/O managment routines
//
// Written by Curtis Olson, started November 1999.
//
// Copyright (C) 1999  Curtis L. Olson - curt@flightgear.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: fg_io.hxx,v 1.1.1.1 2002/09/10 01:14:04 curt Exp $


#ifndef _FG_IO_HXX
#define _FG_IO_HXX


#include <simgear/compiler.h>
#include <vector>
#include STL_STRING

#include "fgfs.hxx"

SG_USING_STD(vector);
SG_USING_STD(string);

class FGProtocol;

class FGIO : public FGSubsystem
{
public:
    FGIO();
    ~FGIO();

    void init();
    void bind();
    void unbind();
    void update( double dt );

    void shutdown_all();

private:

    FGProtocol* parse_port_config( const string& cfgstr );

private:

    // define the global I/O channel list
    //io_container global_io_list;
    vector< FGProtocol* > io_channels;
};


#endif // _FG_IO_HXX
