/*****************************************************************************

 Header:       FGThunderstorm.h	
 Author:       Christian Mayer
 Date started: 02.11.99

 -------- Copyright (C) 1999 Christian Mayer (fgfs@christianmayer.de) --------

 This program is free software; you can redistribute it and/or modify it under
 the terms of the GNU General Public License as published by the Free Software
 Foundation; either version 2 of the License, or (at your option) any later
 version.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 details.

 You should have received a copy of the GNU General Public License along with
 this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 Place - Suite 330, Boston, MA  02111-1307, USA.

 Further information about the GNU General Public License can also be found on
 the world wide web at http://www.gnu.org.

FUNCTIONAL DESCRIPTION
------------------------------------------------------------------------------
Header for the thunderstom class

HISTORY
------------------------------------------------------------------------------
02.11.1999 Christian Mayer	Created
*****************************************************************************/

/****************************************************************************/
/* SENTRY                                                                   */
/****************************************************************************/
#ifndef FGThunderstorm_H
#define FGThunderstorm_H

/****************************************************************************/
/* INCLUDES								    */
/****************************************************************************/
		
/****************************************************************************/
/* DEFINES								    */
/****************************************************************************/

/****************************************************************************/
/* CLASS DECLARATION							    */
/****************************************************************************/
class FGThunderstorm
{
private:
protected:
    float northBorder;
    float eastBorder;
    float southBorder;
    float westBorder;

    float lightningProbability;	//in lightnings per second
    float currentProbability;	//=0.0 directly after a lightning stroke and
				//gets increased over the time until it's
                                //bigger than lightningProbability. When that
				//happens we've got a new lightning

public:
    FGThunderstorm(const float n, const float e, const float s, const float w, const float p, const unsigned int seed = 0);
    ~FGThunderstorm(void);

    void update(const float dt);
};

/****************************************************************************/
#endif /*FGThunderstorm_H*/






